Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jboss.netty.channel.socket.nio
Class NioDatagramChannelFactory

    java.lang.Object
      org.jboss.netty.channel.socket.nio.NioDatagramChannelFactory

All Implemented Interfaces:
  ChannelFactory, DatagramChannelFactory, ExternalResourceReleasable

    public class NioDatagramChannelFactory

extends Object
implements DatagramChannelFactory

A `DatagramChannelFactory` that creates a NIO-based connectionless `DatagramChannel`. It utilizes the non-blocking I/O mode which was introduced with NIO to serve many number of concurrent connections efficiently.

### How threads work

There is only one thread type in a `NioDatagramChannelFactory`; worker threads.

#### Worker threads

One `NioDatagramChannelFactory` can have one or more worker threads. A worker thread performs non-blocking read and write for one or more `DatagramChannel`s in a non-blocking mode.

### Life cycle of threads and graceful shutdown

All worker threads are acquired from the `Executor` which was specified when a `NioDatagramChannelFactory` was created. Therefore, you should make sure the specified `Executor` is able to lend the sufficient number of threads. It is the best bet to specify a cached thread pool.

All worker threads are acquired lazily, and then released when there's nothing left to process. All the related resources such as `Selector` are also released when the worker threads are released. Therefore, to shut down a service gracefully, you should do the following:

1. close all channels created by the factory usually using `ChannelGroup.close()`, and
2. call `releaseExternalResources()`.

Please make sure not to shut down the executor until all channels are closed. Otherwise, you will end up with a `RejectedExecutionException` and the related resources might not be released properly.

### Limitation

Multicast is not supported. Please use `OioDatagramChannelFactory` instead.

Version:
  $Rev: 2200 $, $Date: 2010-02-23 14:42:39 +0900 (Tue, 23 Feb 2010) $
Author:
  The Netty Project, Trustin Lee, Daniel Bevenius (dbevenius@jboss.com)

Constructor Summary
`NioDatagramChannelFactory(Executor workerExecutor)` Creates a new instance.
`NioDatagramChannelFactory(Executor workerExecutor, int workerCount)` Creates a new instance.

Method Summary
`DatagramChannel` | `newChannel(ChannelPipeline pipeline)` Creates and opens a new `Channel` and attaches the specified `ChannelPipeline` to the new `Channel`.
`void` | `releaseExternalResources()` Releases the external resources that this factory depends on to function.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### NioDatagramChannelFactory

    public NioDatagramChannelFactory(Executor workerExecutor)

  Creates a new instance. Calling this constructor is same with calling `NioDatagramChannelFactory(Executor, int)` with 2 * the number of available processors in the machine. The number of available processors is obtained by `Runtime.availableProcessors()`.

  Parameters:
    `workerExecutor` - the `Executor` which will execute the I/O worker threads

### NioDatagramChannelFactory

    public NioDatagramChannelFactory(Executor workerExecutor,
                                     int workerCount)

  Creates a new instance.

  Parameters:
    `workerExecutor` - the `Executor` which will execute the I/O worker threads
    `workerCount` - the maximum number of I/O worker threads

Method Detail

### newChannel

    public DatagramChannel newChannel(ChannelPipeline pipeline)

  Description copied from interface: `ChannelFactory`
  Creates and opens a new `Channel` and attaches the specified `ChannelPipeline` to the new `Channel`.

  Specified by:
    `newChannel` in interface `ChannelFactory`
  Specified by:
    `newChannel` in interface `DatagramChannelFactory`
  Parameters:
    `pipeline` - the `ChannelPipeline` which is going to be attached to the new `Channel`
  Returns:
    the newly open channel

### releaseExternalResources

    public void releaseExternalResources()

  Description copied from interface: `ChannelFactory`
  Releases the external resources that this factory depends on to function. An external resource is a resource that this factory didn't create by itself. For example, `Executor`s that you specified in the factory constructor are external resources. You can call this method to release all external resources conveniently when the resources are not used by this factory or any other part of your application. An unexpected behavior will be resulted in if the resources are released when there's an open channel which is managed by this factory.

  Specified by:
    `releaseExternalResources` in interface `ChannelFactory`
  Specified by:
    `releaseExternalResources` in interface `ExternalResourceReleasable`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2008-2010 JBoss, a division of Red Hat, Inc.. All Rights Reserved.